#!/usr/local/bin/ruby -Ks

########################################
# D Bookmarker ver.3.13
# Copyright (C) 2007 again@T
#   http://nijzero.dw.land.to/
#   tkomaniac@hotmail.com
########################################

require 'webrick'
require 'net/http'
require 'cgi'
require 'kconv'
require 'jcode'

class DbmServlet < WEBrick::HTTPServlet::AbstractServlet
  def do_POST(req, res)
    begin
      @req = req
      @res = res
      @res.content_type = "text/plain; charset=UTF-8"
      @log = req.query['debug'] == '1' ? WEBrick::Log.new(nil,WEBrick::Log::DEBUG) : WEBrick::Log.new
      action
    rescue => evar
      debugLog(evar)
      setResponse(403, '\zÕG[܂')
    end
  end
  
  #needs to be overriden
  def action
    setResponse(403, "ANV`Ă܂")
  end
  
  def setResponse(code, message)
    @res.status = code
    @res.body.concat(message.toutf8)
  end
  
  def debugLog(message)
    @log.debug(message)
  end
  
  def param(name)
    (q = @req.query[name]) ? q.adjustKcode(Kconv::UTF8) : ""
  end
  
  def referer
    @req.header['referer'][0]
  end
  
  def xmlContent
    @res.content_type = "text/xml; charset=UTF-8"
  end
  
  def remoteFileOpen(url)
    begin
      Net::HTTP.version_1_2
      content = Net::HTTP::Proxy($config.proxy, $config.proxy_port).get(url.host, url.request_uri, url.port)
    rescue
      setResponse(403, "ڑɎs܂B")
      return nil
    end
    if content == ""
      setResponse(403, "擾ł܂łB")
      return nil
    end
    return content.adjustKcode
  end
end

class GetTitle < DbmServlet
  def action
    if !(callurl = paramURL)
      setResponse(403, "URL܂B")
      return nil
    end
    debugLog("callurl.host : #{callurl.host}")
    debugLog("callurl.request_uri : #{callurl.request_uri}")
    return nil if !(response = remoteFileOpen(callurl))
    response[/<title.*?>(.*?)<\/title>/im]
    if $1 == nil
      setResponse(403, "^Cg܂łB")
    else
      debugLog("Title match : #{$1}")
      setResponse(200, CGI.unescapeHTML($1))
    end
  end
  
  def paramURL
    parsed = URI.parse(param('url'))
    return parsed.host ? parsed : nil
  end
end

class SaveBookmark < DbmServlet
  def action
    if (savedata = param('dbmhtml'))['<!-- ʏGfBbg̈悱 -->'.adjustKcode] == nil
      debugLog("Query['dbmhtml'] : \n#{savedata}\n")
      setResponse(403, "ۑׂf[^K؂ł܂B")
      return nil
    end
    dbmfilename = decideDbmFile(param('filename'), referer)
    debugLog("dir : #{Dir.pwd}")
    debugLog("filename : #{dbmfilename}")
    begin
      debugLog("Length of Query['dbmhtml'] : #{savedata.length}")
      File.open(dbmfilename, "r") {|current|
        File.open(dbmfilename+".bak", "w") {|backup|
          backup.print(current.read)
        }
      }
      File.open(dbmfilename, "w") {|current|
        current.print(savedata.tosjis)
      }
      setResponse(200, "#{File.expand_path(dbmfilename)}֕ۑ܂B")
    rescue
      setResponse(403, "#{dbmfilename}ւ̕ۑ͂ł܂B")
    end
  end
  
  def decideDbmFile(fninput, refererstr)
    if fninput and fninput != ""
      debugLog("Query['filename'] : #{query}")
      if (fninput[-5..-1].downcase == ".html")||(fninput[-4..-1].downcase == ".htm")
        return fninput
      end
    end
    return "."+URI.parse(refererstr).path
  end
end

class ImportIEFavorites < DbmServlet
  def action
    favpath = current = Dir.getwd
    if fav = param('favfolder')
      favpath = fav if File.directory?(fav)
    end
    if favpath == current
      fav = find_favorites_folder
      favpath = fav if fav
    end
    if favpath == current
      setResponse(403, "Internet Explorer̂Cɓ肪܂łB")
      return nil
    end
    Dir.chdir(favpath)
    debugLog("Start Reading Directory : #{Dir.getwd}")
    linkhash = dir_links(Dir.getwd)
    jsonlines = Array.new
    jsonlines << "["
    jsonlines << linkhash_to_json(linkhash, 'Cɓ聗IE', 1)
    jsonlines << "]"
    jsontext = jsonlines.join("\n")
    jsontext.gsub!(/,\s*\]/, "\n]")
    setResponse(200, jsontext)
    Dir.chdir(current)
  end
  
  #JSON Format
  #[
  # {"name": foldername, "level":levelnum, "links": [
  #  {"name": linkname, "url": url},
  #  {"name": linkname, "url": url},
  #  {"name": linkname, "url": url}
  # ]},
  # {},
  # {}
  #]
  def linkhash_to_json(hash, name, level)
    json = Array.new
    subjson = Array.new
    json << "{\"name\":\"#{name}\", \"level\":#{level}, \"links\": ["
    hash.each do |key, value|
      if value.kind_of?(Hash)
        subjson << linkhash_to_json(value, key, level+1)
      else
        json << "{ \"name\":\"#{key}\", \"url\":\"#{value}\"},"
      end
    end
    json << ']},'
    json << subjson
    return json
  end
  
  def dir_links(path)
    Dir.chdir(path)
    links = Hash.new
    Dir.foreach(path) do |filename|
      if File.directory?(filename)
        if filename != "." and filename != ".."
          current = Dir.getwd
          links[filename] = dir_links(File.expand_path(filename))
          Dir.chdir(current)
        end
      else
        if File.extname(filename) == ".url"
          links[filename[0..-5]] = urlfile_reader(filename)
        end
      end
    end
    return links
  end
  
  def urlfile_reader(fname)
    lines = File.readlines(fname)
    lines.each do |line|
      if line[0..3].downcase == "url="
        return line[4..-1].strip
      end
    end
  end
  
  def find_favorites_folder
    favoritepathlist = Array.new
    wd = ENV['WINDIR']
    un1 = ENV['USER_NAME']
    un2 = ENV['USERNAME']
    up = ENV['USERPROFILE']
    favoritepathlist.push(wd + '\\Favorites') if wd != nil #for Win 9x(single user)
    favoritepathlist.push(wd + '\\Profiles\\' + un1 + '\\Favorites') if (wd != nil) and (un1 != nil) #for Win NT, Win 9x(multiple user)
    favoritepathlist.push(wd + '\\Profiles\\' + un2 + '\\Favorites') if (wd != nil) and (un2 != nil) #for Win NT, Win 9x(multiple user)
    favoritepathlist.push(up + '\\Favorites') if up != nil #for Win 2000, XP, Vista
    alive = nil
    favoritepathlist.each do |fpath|
      alive = fpath if File.directory?(fpath)
    end
    return alive
  end
end

class CutLinkChecker < DbmServlet
  def action
    urllist = param('urllist').split("\n")
    threads = Array.new
    for url in urllist
      threads << Thread.new(url) do |url_local|
        callurl = URI.parse(url_local.strip)
        callurl = nil if callurl.host == nil
        Thread.current["url"] = callurl
        Thread.current["alive"] = live_url(callurl)
      end
    end
    threads.each do |thr|
      begin
        thr.join(10)
      rescue
        debugLog("thread failed about #{thr['url']}")
      end
    end
    setResponse(200, result_json(threads))
  end
  
  #JSON Format
  #[true, false, null]
  def result_json(threads)
    bools = Array.new
    threads.each do |thr|
      if thr["alive"] == nil
        bools << "null"
      else
        bools << thr["alive"]
      end
    end
    result = "["
    result << bools.join(", ")
    result << "]"
    return result
  end
  
  def live_url(url)
    if url.host == nil
      debugLog("Not valid url: #{url}")
      return nil
    end
    debugLog("url host : #{url.host} ; request_uri : #{url.request_uri}")
    begin
      Net::HTTP.version_1_2
      http = Net::HTTP::Proxy($config.proxy, $config.proxy_port).new(url.host, url.port)
      http.open_timeout=5
      reqtype = ["HEAD", "GET"]
      reqtype.each do |type|
        req = request_maker(type, url.host, url.request_uri)
        res = http.request(req)
        debugLog("response returned from #{url}; code: #{res.code}")
        if (res.code == "200") or (res.code == "304")
          return true
        elsif res.code[0..1] != "40"
          return false
        end
      end
      return false
    rescue
      debugLog("connection failed to #{url}")
      return nil
    end
  end
  
  def request_maker(methodname, host, path)
    if methodname == "GET"
      req = Net::HTTP::GET.new(path)
    elsif methodname == "HEAD"
      req = Net::HTTP::Head.new(path)
    else
      return nil;
    end
    req['If-Modified-Since'] = Time.now.gmtime.strftime("%a, %d %b %Y %H:%M:%S GMT")
    req['Host'] = host
    req['Accept'] = '*/*'
    req['Accept-Language'] = 'ja'
    return req;
  end
end

class MetaSearchUpdater < DbmServlet
  def action
    callurl = URI.parse((urlstr=param('url')) != "" ? urlstr : "http://nijzero.dw.land.to/software/dbmsearchform.html")
    debugLog("callurl : #{callurl}")
    if callurl.host == nil 
      setResponse(403, "URL܂B")
      return nil
    end
    debugLog("callurl.host : #{callurl.host}")
    debugLog("callurl.request_uri : #{callurl.request_uri}")
    return nil if !(response = remoteFileOpen(callurl))
    response[/<textarea.*?>(.*?)<\/textarea>/im]
    if $1 == nil
      setResponse(403, "eLXgGA܂łB")
      return nil
    end
    debugLog("Textarea length: #{$1.length}")
    xmlContent
    forms = '<?xml version="1.0" encoding="UTF-8"?>'
    forms += "\n<forms>"
    forms += CGI.unescapeHTML($1)
    forms += "</forms>"
    setResponse(200, forms)
  end
end

class Configuration
  def port
    @port
  end
  def broadcast
    @broadcast
  end
  def proxy
    @proxy
  end
  def proxy_port
    @proxy_port
  end
  def initialize(filename)
    @port = 50080
    @broadcast = false
    @proxy = nil
    @proxy_port = nil
    $SRCKC = Kconv.toConst($KCODE)
    $KCODE = "SJIS"
    readFile(filename)
  end
  
  def readFile(filename)
    begin
      File.foreach(filename) do |line|
        key, value = line.split("=")
        next if !value
        key, value = key.strip, value.strip
        case key
        when "port"
          @port = value.to_i if value.to_i>0 and value.to_i<65536
        when "broadcast"
          @broadcast = true if value == "1"
        when "proxy"
          @proxy = value if value != ""
        when "proxy_port"
          @proxy_port = value.to_i if value.to_i>0 and value.to_i<65536
        when "kcode"
          $KCODE = value if ["s","e","u"].include?(value[0..0].downcase)
        end
      end
    rescue
      puts "ݒt@C'#{filename}'܂BݒŋN܂B".adjustKcode($SRCKC)
    end
  end
end

class String
  def adjustKcode(srccode=Kconv::AUTO)
    self.kconv(Kconv.toConst($KCODE), srccode)
  end
end

module Kconv
  def self.toConst(kcodestr)
    kc = {"SJIS" => Kconv::SJIS, "EUC" => Kconv::EUC, "UTF8" => Kconv::UTF8}
    kc.default = Kconv::SJIS
    kc[kcodestr]
  end
end

###main 

$config = Configuration.new(ARGV.length>0 ? ARGV[0] : "server.ini")

begin
  tcp = TCPSocket.open('127.0.0.1', $config.port)
  tcp.close
  puts "|[gԍ#{$config.port}͊ɎgpĂ̂ŋNł܂B\nEnterƏI܂B".adjustKcode($SRCKC)
  gets 
  exit
rescue
end

s = WEBrick::HTTPServer.new( :Port => $config.port,
      :BindAddress => $config.broadcast ? nil : '127.0.0.1',
      :DocumentRoot  =>  File.dirname( __FILE__ )  )
s.mount("/savebm", SaveBookmark)
s.mount("/gettitle", GetTitle)
s.mount("/importie", ImportIEFavorites)
s.mount("/cutlink", CutLinkChecker)
s.mount("/updatesearch", MetaSearchUpdater)

trap("INT"){s.shutdown}
s.logger.info("D Bookmarker Server ver.3.13")
s.logger.info("T[oN܂B(broadcast=#{$config.broadcast})\nCtrl(Control, Command)+CƏI܂B\n\n".adjustKcode($SRCKC))

s.start
